#!/usr/bin/python
import sys

ring="Real"
n=int(sys.argv[1])
deltaY=2
deltaZ=3
add_fast_clauses=False
use_ite=True

if ring == "Int":
  print "(set-logic QF_LIA)"
elif ring == "Real":
  print "(set-logic QF_LRA)"

for i in xrange(n):
  print "(declare-fun x{0} () {1})".format(i, ring)
  print "(declare-fun b{0} () Bool)".format(i)

print

for i in xrange(n):
  if use_ite:
    print "(assert (= x{0} (ite b{0} {1} {2})))".format(i, deltaY, deltaZ)
  else:
    print "(assert (or (= x{0} {1}) (= x{0} {2})))".format(i, deltaY, deltaZ)
  
print
print "(assert (> (+",
for i in xrange(n):
  print "x{0} ".format(i),
print ") {0}))".format(max(deltaY, deltaZ)*n)
print "(check-sat)"

