#!/usr/bin/python
import sys

ring="Real"
n=int(sys.argv[1])
deltaY=2
deltaZ=3
add_fast_clauses=False
use_ite=True
gen_opt=True

if ring == "Int":
  print "(set-logic QF_LIA)"
elif ring == "Real":
  print "(set-logic QF_LRA)"

if gen_opt:
  print "(declare-fun cost () {0})".format(ring)
 
for i in xrange(n):
  print "(declare-fun x{0} () {1})".format(i, ring)
  print "(declare-fun y{0} () {1})".format(i, ring)
  print "(declare-fun b{0} () Bool)".format(i)

print

for i in xrange(n):
  if use_ite:
    print "(assert (= x{0} (ite b{0} {1} {2})))".format(i, deltaY, deltaZ)
    print "(assert (= y{0} (ite b{0} {1} {2})))".format(i, deltaZ, deltaY)
  else:
    print "(assert (or (= x{0} {1}) (= x{0} {2})))".format(i, deltaY, deltaZ)
    print "(assert (or (= y{0} {1}) (= x{0} {2})))".format(i, deltaZ, deltaY)
  if add_fast_clauses:
    print "(assert (<= (+ x{0} y{0}) {1}))".format(i, deltaY+deltaZ)
    
print
if gen_opt:
  print "(assert (= cost (+",
else:
  print "(assert (> (+",
for i in xrange(n):
  print "x{0} y{0}".format(i),
if gen_opt:
  print ")))"
else:
  print ") {0}))".format((deltaY + deltaZ)*n)
print "(check-sat)"

