#include "any.h"

// TODO precondition to enforce, but should be proven in the main
/*@ requires 0 <= x ;
  @ assigns \nothing;
  @ ensures \result * y <= x;
  @ ensures x - \result * y < y;
  @*/
int div(int x,int y) {
  int i=0;
  
  // TODO : enfirce the invariant
  /*@ loop invariant x<=x; 
    @ loop assigns i,x ;
    @ loop variant x; */
  while (y <= x) {
    i++;
    x-=y;
  }
  return i;
}


int main() {
  int x=any(), y=any(), q;

  if (x < 0) x=0;
  if (y < 1) y=1;

  q=div(x,y);

  /*@ assert q*y <= x; */
  /*@ assert x-q*y < y; */

  return q;
}
